Bug Hunting Session
Bug 77603 - new wildcard in autocorrection: .* instead of *
Summary: new wildcard in autocorrection: .* instead of *
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Linguistic (show other bugs)
Version:
(earliest affected)
4.2.0.0.alpha0+ Master
Hardware: Other All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard: target:4.3.0 target:4.2.4 target:4.4.0
Keywords:
Depends on:
Blocks:
 
Reported: 2014-04-18 05:31 UTC by tommy27
Modified: 2014-07-04 09:06 UTC (History)
4 users (show)

See Also:
Crash report or crash signature:


Attachments
patch to update wildcards in French auotocorrection file (11.07 KB, patch)
2014-04-22 16:50 UTC, Olivier R.
Details

Note You need to log in before you can comment on or make changes to this bug.
Description tommy27 2014-04-18 05:31:35 UTC
wildcard autocorrection with the key "*" has been introduced in LibO 4.2.x (see Bug 68373)

this new feature can be useful indeed but may also cause unexpected autocorrections when using autocorrect replacement tables from older LibO releases containing entries with the key "*" (which was considered a regular typing character in those versions) as explained in Bug 77508

this happened to me since I was unaware of the new feature (which is also not published in the 4.2.x release notes https://wiki.documentfoundation.org/ReleaseNotes/4.2).

so IMHO such a new feature should be set as an option in the "AutoCorrect/Options" table and probably it should set by defaul in "off" state so only experienced user could turn it on.

@Lazlo
what do you think about it? is this something feasible?
Comment 1 Joel Madero 2014-04-18 05:52:16 UTC
I have really mixed feelings about this to be honest - there's only so many options we can have and already our options are overcrowded . . . I understand you lost some functionality but having option upon option to ensure that every use case is covered makes our option dialog unusable
Comment 2 tommy27 2014-04-18 06:24:54 UTC
hi Joel, let me respectfully disagree.

I don't think the autocorrection option are that much overcrowded see screenshot in attachment 97481 [details].

as we already have autocorrect options about "double space", "capital letters" and all other stuff, I think that an option for wildcards which may have an even deeper impact on autocorrection in respect to other existing option is needed.

regarding me I have no troubles using current 4.2.x since I know that I must avoid that asterisk key in my replacement table

but I'm thinking about less experienced users who will be probably completely unaware of autocorrect wildcard feature which is unpublished in the release notes and uncited in the autocorrect GUI option page. 

this new feature at the moment is known only to a few developers and QA guys but largely unknown by the user base and can cause unexplainable issues like the one I have experienced.

I'd like to hear Lazlo opinion about it.

by the way could you set status to this enhancement request as NEW?
then Lazlo will decide if it's a WONTFIX or ASSIGNED task.
Comment 3 Cor Nouws 2014-04-18 21:49:28 UTC
(In reply to comment #2)

> I don't think the autocorrection option are that much overcrowded see
> screenshot in attachment 97481 [details].

Indeed, the Localized options are done in a list by purpose, to make room for more ;)
Comment 4 László Németh 2014-04-18 22:16:28 UTC
Unfortunately, the help hasn't been updated yet (there was only a little news: http://libreoffice.hu/2013/08/26/pattern-matching-in-autocorrect/). Maybe a larger minimum character length could help here, or a more special notation, eg. the regex ".*", instead of a new option. I will check it, and will update the help, too. Thanks for your bug report!
Comment 5 tommy27 2014-04-19 04:41:51 UTC
(In reply to comment #4)
> ....
> Maybe a larger minimum character length could help here, or a more special
> notation, eg. the regex ".*", instead of a new option. 

thanks for thinking about it.
my 2 cents is that the new feature has good potential but probably needs some tweaking to avoid to be accidentally triggered by users who are unaware of it.

probably you should choose a different key or key combination to be used as a wildcard.

the key "*" in indeed too easily accessible and can already be part of previous autocorrect list causing disfunction like those I've encountered...

for example in an italian layout keyboard the "*" is close to the "é" key which is a font present at the end of many italian words (i.e. perché, pressoché etc. etc.)

so there are high chances that an italian user sets an autocorrect couple like:

perch* --> perché

unfortunately if you digit similar typos hitting nearby keys like "p" or "à"
the wildcard * will trigger unwanted corrections like:

perchp --> perchép
perchà --> perchéà

which is really really bad.

so bottomline is that the feature has to be kept but refined to avoid accidental side effect.

I still think that an option like "enable/disable * wildcard autocorrect" would be a proper solution.

a second option would be to change the wildcard to the simple * key to a more elaborated regex-like key combination like you proposed for ".*" which has really no chance to be accidentally typed by unaware users.

it's very unlikely that a user has an autocorrect couple like:

perch".*" --> perchè

unless he is well-aware of what a regex is.

a change in the wildcard autocorrection feature will probably be well tolerated by users since I think it was not very advertised and I bet most of our user base don't even know that it exist, me too I was thinking tha "it was a bug, not a feature"  :-)
Comment 6 László Németh 2014-04-20 23:41:00 UTC
I will change "*" with ".*", thanks for your feedback!

Note: the help was updated, so we will need only a minor update: https://help.libreoffice.org/swriter/cui/ui/acorreplacepage/origtext?Language=en-US&System=UNIX&Version=4.2#bm_id1574449

Interestingly, I just found this old feature request: http://ask.libreoffice.org/en/question/2052/wildcard-in-autocorrect/
Comment 7 Commit Notification 2014-04-21 10:47:40 UTC
Laszlo Nemeth committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=022e351c2431e0260220a51a54d576f49f789ebc

fdo#77603 new wildcard in autocorrection: .* instead of *



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 8 Commit Notification 2014-04-21 11:27:51 UTC
Laszlo Nemeth committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/help/commit/?id=4a202ac51e3cfda0dc2e52392e394bf51f185f38

fdo#77603 update help (new wildcard in autocorrection)



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 9 Commit Notification 2014-04-21 12:02:59 UTC
Laszlo Nemeth committed a patch related to this issue.
It has been pushed to "libreoffice-4-2-4":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=43ef8c7b9be569484077a237f4c460ced24e9673&h=libreoffice-4-2-4

fdo#77603 new wildcard in autocorrection: .* instead of *


It will be available already in LibreOffice 4.2.4.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 10 Commit Notification 2014-04-21 12:05:30 UTC
Laszlo Nemeth committed a patch related to this issue.
It has been pushed to "libreoffice-4-2":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=27810fa1ffe84fd326a1fc6d251fe6a187045ad6&h=libreoffice-4-2

fdo#77603 new wildcard in autocorrection: .* instead of *


It will be available in LibreOffice 4.2.5.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 11 László Németh 2014-04-21 12:10:03 UTC
Fixed in master and LibreOffice 4.2, too, by the replacement of wildcard * with .*
Thanks for your bug report and comments.
Comment 12 tommy27 2014-04-22 16:06:57 UTC
thanks Lazlo.

changing the autocorrect wildcard from * to .* looks a good solution to me.

it's probably enough to avoid accidental conflicts with users using old autocorrect database where is very unlikely that people had autocorrect entries with .* at the end of words.

for this reason I change summary notes from original description:
"*" key wildcard autocorrection should be an option

into this which matches your committ summary notes:
new wildcard in autocorrection: .* instead of *
Comment 13 Olivier R. 2014-04-22 16:50:39 UTC
Created attachment 97761 [details]
patch to update wildcards in French auotocorrection file

Hi László,

Can you also update the repos with this patch, please?
We already used the old widcard syntax.
Comment 14 tommy27 2014-04-22 18:08:54 UTC
well done Oliver.
I hope it will be fixed it before 4.2.4 rc2
see detailed schedule here:
https://wiki.documentfoundation.org/ReleasePlan/4.2#4.2.4_release
Comment 15 László Németh 2014-04-23 10:22:54 UTC
(In reply to comment #13)
Hi, Olivier, sorry for the unnoticed replacement and many thanks for the patch. It is in the master, libreoffice-4-2, and it seems, in libreoffice-4-2-4, too. By the way, I very much like your autocorrection patterns.
Comment 16 László Németh 2014-04-23 10:35:23 UTC
In reply to comment #12)
Many thanks for your feedback, and changing the summary!

I have added the missing wildcard-in-autocorrection item to the release notes: 

https://wiki.documentfoundation.org/ReleaseNotes/4.2#Writer, 

also here is my answer on the ask.libreoffice, too:

http://ask.libreoffice.org/en/question/2052/wildcard-in-autocorrect/?answer=32997#post-id-32997
Comment 17 tommy27 2014-04-23 12:14:34 UTC
good job Lazlo,
I have VERIFIED your fix in Version: 4.3.0.0.alpha0+
Build ID: 870ce1188ef7bfb6e57eed2894a20b2ea30b2225
TinderBox: Win-x86@39, Branch:master, Time: 2014-04-22_00:13:36
Comment 18 Commit Notification 2014-07-04 09:06:12 UTC
Adolfo Jayme Barrientos committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=26890920b7a05817f6542dd807cb2b10c38c17c4

Related fdo#77603: update Spanish autocorrection patterns.



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.